//---------------------------------------------------------------------------
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//
//                                                    Albert Lee 2003/12/09
//---------------------------------------------------------------------------
#ifndef TZlibH
#define TZlibH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
extern "C" {
#include "zlib.h"
}
//---------------------------------------------------------------------------
#undef	PROCESS_MSG_ON_ZLIB
#undef	ENLARGE_STREAM_ON_PROCESS
//---------------------------------------------------------------------------
#ifndef	PROCESS_MSG_ON_ZLIB
	#define ZLibMsgHandler()   ((void)0)
#endif	//PROCESS_MSG_ON_ZLIB
//---------------------------------------------------------------------------
#define Z_ALLOCATE_BLOCK		(128*1024)
//#define Z_BUFFER_SIZE 1024  	// the size of the input and output buffers
//#define Z_BUFFER_SIZE 2048  	// the size of the input and output buffers
//#define Z_BUFFER_SIZE 4096  	// the size of the input and output buffers
#define Z_BUFFER_SIZE 8192  	// the size of the input and output buffers
//#define Z_BUFFER_SIZE 10240 	// the size of the input and output buffers
//#define Z_BUFFER_SIZE 16384 	// the size of the input and output buffers
#define Z_USER_ABORT (-7)		// add one error code to those found in zlib.h
//---------------------------------------------------------------------------
class TZLibBase : public TObject
{
public :
	__fastcall TZLibBase(void);
	__fastcall ~TZLibBase(void);
	virtual int __fastcall Percent(void);
	virtual const char* __fastcall ZLibVersion(void);

protected :
	z_stream *ZLibRec;
	unsigned char OutputBuffer[Z_BUFFER_SIZE];
	unsigned char InputBuffer[Z_BUFFER_SIZE];
	long Length;
#ifdef	PROCESS_MSG_ON_ZLIB
	void __fastcall ZLibMsgHandler(void);
#endif	//PROCESS_MSG_ON_ZLIB
	virtual int __fastcall LoadInput(TStream* InStream, z_stream *ZLibRec);
	virtual int __fastcall FlushOutput(TStream* OutStream, z_stream *ZLibRec);
private:
};
//---------------------------------------------------------------------------
class TZLibCompressionStream : public TZLibBase
{
public :
	__fastcall TZLibCompressionStream(void);
	__fastcall ~TZLibCompressionStream(void);
	int __fastcall Compress(TStream*, TStream*, int);
	bool UserAbort;

protected :

private:
};
//---------------------------------------------------------------------------
class TZLibDecompressionStream : public TZLibBase
{
public :
	__fastcall TZLibDecompressionStream(void);
	__fastcall ~TZLibDecompressionStream(void);
	int __fastcall Decompress(TStream*, TStream*);
	bool UserAbort;
protected :

private:
};
//---------------------------------------------------------------------------
#endif  // #ifndef TZlibH



